@REM avr_boot bootloader build batch file

@echo off
echo making avr_boot bootloader files...

REM add make.exe and rm.exe location to path
path=C:\Program Files (x86)\make

REM add avr-gcc location to path
path=%PATH%;C:\Program Files\avr-gcc-6.1.0-x64-mingw\hardware\tools\avr\bin

make MCU_TARGET=atmega328 BOOT_ADR=0x7000 F_CPU=8000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_cs4_$(F_CPU)L > buildlog.txt 2>&1
make MCU_TARGET=atmega328 BOOT_ADR=0x7000 F_CPU=8000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=0 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_cs8_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega328 BOOT_ADR=0x7000 F_CPU=8000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=2 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_cs10_$(F_CPU)L >> buildlog.txt 2>>&1

make MCU_TARGET=atmega328 BOOT_ADR=0x7000 F_CPU=16000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega328 BOOT_ADR=0x7000 F_CPU=16000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=0 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_cs8_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega328 BOOT_ADR=0x7000 F_CPU=16000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=2 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_cs10_$(F_CPU)L >> buildlog.txt 2>>&1

make MCU_TARGET=atmega328 BOOT_ADR=0x7000 F_CPU=20000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega328 BOOT_ADR=0x7000 F_CPU=20000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=0 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_cs8_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega328 BOOT_ADR=0x7000 F_CPU=20000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=2 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_cs10_$(F_CPU)L >> buildlog.txt 2>>&1


make MCU_TARGET=atmega328p BOOT_ADR=0x7000 F_CPU=8000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega328p BOOT_ADR=0x7000 F_CPU=8000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=0 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_cs8_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega328p BOOT_ADR=0x7000 F_CPU=8000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=2 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_cs10_$(F_CPU)L >> buildlog.txt 2>>&1

make MCU_TARGET=atmega328p BOOT_ADR=0x7000 F_CPU=16000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega328p BOOT_ADR=0x7000 F_CPU=16000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=0 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_cs8_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega328p BOOT_ADR=0x7000 F_CPU=16000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=2 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_cs10_$(F_CPU)L >> buildlog.txt 2>>&1

make MCU_TARGET=atmega328p BOOT_ADR=0x7000 F_CPU=20000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega328p BOOT_ADR=0x7000 F_CPU=20000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=0 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_cs8_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega328p BOOT_ADR=0x7000 F_CPU=20000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=2 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_cs10_$(F_CPU)L >> buildlog.txt 2>>&1


make MCU_TARGET=atmega32u4 BOOT_ADR=0x7000 F_CPU=8000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega32u4 BOOT_ADR=0x7000 F_CPU=8000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_cs8_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega32u4 BOOT_ADR=0x7000 F_CPU=8000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=6 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_cs10_$(F_CPU)L >> buildlog.txt 2>>&1

make MCU_TARGET=atmega32u4 BOOT_ADR=0x7000 F_CPU=16000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega32u4 BOOT_ADR=0x7000 F_CPU=16000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_cs8_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega32u4 BOOT_ADR=0x7000 F_CPU=16000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=6 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_cs10_$(F_CPU)L >> buildlog.txt 2>>&1

make MCU_TARGET=atmega32u4 BOOT_ADR=0x7000 F_CPU=20000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega32u4 BOOT_ADR=0x7000 F_CPU=20000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_cs8_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega32u4 BOOT_ADR=0x7000 F_CPU=20000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=6 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_cs10_$(F_CPU)L >> buildlog.txt 2>>&1


make MCU_TARGET=atmega1284 BOOT_ADR=0x1F000 F_CPU=8000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v0_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega1284 BOOT_ADR=0x1F000 F_CPU=8000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=0 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v1_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega1284 BOOT_ADR=0x1F000 F_CPU=8000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=0 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v2_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega1284 BOOT_ADR=0x1F000 F_CPU=8000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v3_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega1284 BOOT_ADR=0x1F000 F_CPU=8000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=3 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v4_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega1284 BOOT_ADR=0x1F000 F_CPU=8000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v5_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega1284 BOOT_ADR=0x1F000 F_CPU=8000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=3 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v6_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega1284 BOOT_ADR=0x1F000 F_CPU=8000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=0 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v0_cs8_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega1284 BOOT_ADR=0x1F000 F_CPU=8000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=5 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v1_cs8_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega1284 BOOT_ADR=0x1F000 F_CPU=8000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=6 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v2_cs8_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega1284 BOOT_ADR=0x1F000 F_CPU=8000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=2 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v3_cs8_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega1284 BOOT_ADR=0x1F000 F_CPU=8000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v4_cs8_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega1284 BOOT_ADR=0x1F000 F_CPU=8000000 SD_CS_PORT=PORTC SD_CS_DDR=DDRC SD_CS_BIT=0 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v5_cs8_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega1284 BOOT_ADR=0x1F000 F_CPU=8000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=2 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v6_cs8_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega1284 BOOT_ADR=0x1F000 F_CPU=8000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=2 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v0_cs10_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega1284 BOOT_ADR=0x1F000 F_CPU=8000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v1_cs10_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega1284 BOOT_ADR=0x1F000 F_CPU=8000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v2_cs10_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega1284 BOOT_ADR=0x1F000 F_CPU=8000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v3_cs10_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega1284 BOOT_ADR=0x1F000 F_CPU=8000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=7 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v4_cs10_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega1284 BOOT_ADR=0x1F000 F_CPU=8000000 SD_CS_PORT=PORTC SD_CS_DDR=DDRC SD_CS_BIT=2 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v5_cs10_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega1284 BOOT_ADR=0x1F000 F_CPU=8000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v6_cs10_$(F_CPU)L >> buildlog.txt 2>>&1

make MCU_TARGET=atmega1284 BOOT_ADR=0x1F000 F_CPU=16000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v0_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega1284 BOOT_ADR=0x1F000 F_CPU=16000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=0 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v1_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega1284 BOOT_ADR=0x1F000 F_CPU=16000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=0 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v2_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega1284 BOOT_ADR=0x1F000 F_CPU=16000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v3_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega1284 BOOT_ADR=0x1F000 F_CPU=16000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=3 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v4_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega1284 BOOT_ADR=0x1F000 F_CPU=16000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v5_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega1284 BOOT_ADR=0x1F000 F_CPU=16000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=3 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v6_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega1284 BOOT_ADR=0x1F000 F_CPU=16000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=0 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v0_cs8_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega1284 BOOT_ADR=0x1F000 F_CPU=16000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=5 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v1_cs8_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega1284 BOOT_ADR=0x1F000 F_CPU=16000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=6 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v2_cs8_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega1284 BOOT_ADR=0x1F000 F_CPU=16000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=2 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v3_cs8_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega1284 BOOT_ADR=0x1F000 F_CPU=16000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v4_cs8_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega1284 BOOT_ADR=0x1F000 F_CPU=16000000 SD_CS_PORT=PORTC SD_CS_DDR=DDRC SD_CS_BIT=0 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v5_cs8_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega1284 BOOT_ADR=0x1F000 F_CPU=16000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=2 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v6_cs8_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega1284 BOOT_ADR=0x1F000 F_CPU=16000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=2 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v0_cs10_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega1284 BOOT_ADR=0x1F000 F_CPU=16000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v1_cs10_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega1284 BOOT_ADR=0x1F000 F_CPU=16000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v2_cs10_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega1284 BOOT_ADR=0x1F000 F_CPU=16000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v3_cs10_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega1284 BOOT_ADR=0x1F000 F_CPU=16000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=7 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v4_cs10_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega1284 BOOT_ADR=0x1F000 F_CPU=16000000 SD_CS_PORT=PORTC SD_CS_DDR=DDRC SD_CS_BIT=2 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v5_cs10_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega1284 BOOT_ADR=0x1F000 F_CPU=16000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v6_cs10_$(F_CPU)L >> buildlog.txt 2>>&1

make MCU_TARGET=atmega1284 BOOT_ADR=0x1F000 F_CPU=20000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v0_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega1284 BOOT_ADR=0x1F000 F_CPU=20000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=0 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v1_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega1284 BOOT_ADR=0x1F000 F_CPU=20000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=0 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v2_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega1284 BOOT_ADR=0x1F000 F_CPU=20000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v3_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega1284 BOOT_ADR=0x1F000 F_CPU=20000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=3 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v4_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega1284 BOOT_ADR=0x1F000 F_CPU=20000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v5_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega1284 BOOT_ADR=0x1F000 F_CPU=20000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=3 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v6_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega1284 BOOT_ADR=0x1F000 F_CPU=20000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=0 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v0_cs8_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega1284 BOOT_ADR=0x1F000 F_CPU=20000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=5 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v1_cs8_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega1284 BOOT_ADR=0x1F000 F_CPU=20000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=6 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v2_cs8_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega1284 BOOT_ADR=0x1F000 F_CPU=20000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=2 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v3_cs8_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega1284 BOOT_ADR=0x1F000 F_CPU=20000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v4_cs8_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega1284 BOOT_ADR=0x1F000 F_CPU=20000000 SD_CS_PORT=PORTC SD_CS_DDR=DDRC SD_CS_BIT=0 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v5_cs8_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega1284 BOOT_ADR=0x1F000 F_CPU=20000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=2 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v6_cs8_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega1284 BOOT_ADR=0x1F000 F_CPU=20000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=2 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v0_cs10_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega1284 BOOT_ADR=0x1F000 F_CPU=20000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v1_cs10_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega1284 BOOT_ADR=0x1F000 F_CPU=20000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v2_cs10_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega1284 BOOT_ADR=0x1F000 F_CPU=20000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v3_cs10_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega1284 BOOT_ADR=0x1F000 F_CPU=20000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=7 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v4_cs10_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega1284 BOOT_ADR=0x1F000 F_CPU=20000000 SD_CS_PORT=PORTC SD_CS_DDR=DDRC SD_CS_BIT=2 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v5_cs10_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega1284 BOOT_ADR=0x1F000 F_CPU=20000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v6_cs10_$(F_CPU)L >> buildlog.txt 2>>&1


make MCU_TARGET=atmega1284p BOOT_ADR=0x1F000 F_CPU=8000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v0_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega1284p BOOT_ADR=0x1F000 F_CPU=8000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=0 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v1_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega1284p BOOT_ADR=0x1F000 F_CPU=8000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=0 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v2_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega1284p BOOT_ADR=0x1F000 F_CPU=8000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v3_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega1284p BOOT_ADR=0x1F000 F_CPU=8000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=3 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v4_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega1284p BOOT_ADR=0x1F000 F_CPU=8000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v5_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega1284p BOOT_ADR=0x1F000 F_CPU=8000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=3 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v6_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega1284p BOOT_ADR=0x1F000 F_CPU=8000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=0 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v0_cs8_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega1284p BOOT_ADR=0x1F000 F_CPU=8000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=5 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v1_cs8_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega1284p BOOT_ADR=0x1F000 F_CPU=8000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=6 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v2_cs8_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega1284p BOOT_ADR=0x1F000 F_CPU=8000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=2 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v3_cs8_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega1284p BOOT_ADR=0x1F000 F_CPU=8000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v4_cs8_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega1284p BOOT_ADR=0x1F000 F_CPU=8000000 SD_CS_PORT=PORTC SD_CS_DDR=DDRC SD_CS_BIT=0 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v5_cs8_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega1284p BOOT_ADR=0x1F000 F_CPU=8000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=2 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v6_cs8_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega1284p BOOT_ADR=0x1F000 F_CPU=8000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=2 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v0_cs10_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega1284p BOOT_ADR=0x1F000 F_CPU=8000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v1_cs10_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega1284p BOOT_ADR=0x1F000 F_CPU=8000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v2_cs10_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega1284p BOOT_ADR=0x1F000 F_CPU=8000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v3_cs10_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega1284p BOOT_ADR=0x1F000 F_CPU=8000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=7 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v4_cs10_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega1284p BOOT_ADR=0x1F000 F_CPU=8000000 SD_CS_PORT=PORTC SD_CS_DDR=DDRC SD_CS_BIT=2 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v5_cs10_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega1284p BOOT_ADR=0x1F000 F_CPU=8000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v6_cs10_$(F_CPU)L >> buildlog.txt 2>>&1

make MCU_TARGET=atmega1284p BOOT_ADR=0x1F000 F_CPU=16000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v0_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega1284p BOOT_ADR=0x1F000 F_CPU=16000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=0 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v1_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega1284p BOOT_ADR=0x1F000 F_CPU=16000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=0 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v2_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega1284p BOOT_ADR=0x1F000 F_CPU=16000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v3_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega1284p BOOT_ADR=0x1F000 F_CPU=16000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=3 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v4_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega1284p BOOT_ADR=0x1F000 F_CPU=16000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v5_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega1284p BOOT_ADR=0x1F000 F_CPU=16000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=3 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v6_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega1284p BOOT_ADR=0x1F000 F_CPU=16000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=0 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v0_cs8_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega1284p BOOT_ADR=0x1F000 F_CPU=16000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=5 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v1_cs8_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega1284p BOOT_ADR=0x1F000 F_CPU=16000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=6 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v2_cs8_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega1284p BOOT_ADR=0x1F000 F_CPU=16000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=2 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v3_cs8_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega1284p BOOT_ADR=0x1F000 F_CPU=16000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v4_cs8_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega1284p BOOT_ADR=0x1F000 F_CPU=16000000 SD_CS_PORT=PORTC SD_CS_DDR=DDRC SD_CS_BIT=0 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v5_cs8_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega1284p BOOT_ADR=0x1F000 F_CPU=16000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=2 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v6_cs8_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega1284p BOOT_ADR=0x1F000 F_CPU=16000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=2 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v0_cs10_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega1284p BOOT_ADR=0x1F000 F_CPU=16000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v1_cs10_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega1284p BOOT_ADR=0x1F000 F_CPU=16000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v2_cs10_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega1284p BOOT_ADR=0x1F000 F_CPU=16000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v3_cs10_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega1284p BOOT_ADR=0x1F000 F_CPU=16000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=7 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v4_cs10_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega1284p BOOT_ADR=0x1F000 F_CPU=16000000 SD_CS_PORT=PORTC SD_CS_DDR=DDRC SD_CS_BIT=2 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v5_cs10_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega1284p BOOT_ADR=0x1F000 F_CPU=16000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v6_cs10_$(F_CPU)L >> buildlog.txt 2>>&1

make MCU_TARGET=atmega1284p BOOT_ADR=0x1F000 F_CPU=20000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v0_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega1284p BOOT_ADR=0x1F000 F_CPU=20000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=0 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v1_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega1284p BOOT_ADR=0x1F000 F_CPU=20000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=0 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v2_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega1284p BOOT_ADR=0x1F000 F_CPU=20000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v3_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega1284p BOOT_ADR=0x1F000 F_CPU=20000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=3 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v4_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega1284p BOOT_ADR=0x1F000 F_CPU=20000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v5_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega1284p BOOT_ADR=0x1F000 F_CPU=20000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=3 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v6_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega1284p BOOT_ADR=0x1F000 F_CPU=20000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=0 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v0_cs8_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega1284p BOOT_ADR=0x1F000 F_CPU=20000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=5 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v1_cs8_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega1284p BOOT_ADR=0x1F000 F_CPU=20000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=6 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v2_cs8_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega1284p BOOT_ADR=0x1F000 F_CPU=20000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=2 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v3_cs8_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega1284p BOOT_ADR=0x1F000 F_CPU=20000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v4_cs8_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega1284p BOOT_ADR=0x1F000 F_CPU=20000000 SD_CS_PORT=PORTC SD_CS_DDR=DDRC SD_CS_BIT=0 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v5_cs8_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega1284p BOOT_ADR=0x1F000 F_CPU=20000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=2 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v6_cs8_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega1284p BOOT_ADR=0x1F000 F_CPU=20000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=2 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v0_cs10_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega1284p BOOT_ADR=0x1F000 F_CPU=20000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v1_cs10_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega1284p BOOT_ADR=0x1F000 F_CPU=20000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v2_cs10_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega1284p BOOT_ADR=0x1F000 F_CPU=20000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v3_cs10_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega1284p BOOT_ADR=0x1F000 F_CPU=20000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=7 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v4_cs10_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega1284p BOOT_ADR=0x1F000 F_CPU=20000000 SD_CS_PORT=PORTC SD_CS_DDR=DDRC SD_CS_BIT=2 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v5_cs10_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega1284p BOOT_ADR=0x1F000 F_CPU=20000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v6_cs10_$(F_CPU)L >> buildlog.txt 2>>&1


make MCU_TARGET=atmega644 BOOT_ADR=0xF000 F_CPU=8000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v0_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega644 BOOT_ADR=0xF000 F_CPU=8000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=0 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v1_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega644 BOOT_ADR=0xF000 F_CPU=8000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=0 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v2_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega644 BOOT_ADR=0xF000 F_CPU=8000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v3_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega644 BOOT_ADR=0xF000 F_CPU=8000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=3 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v4_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega644 BOOT_ADR=0xF000 F_CPU=8000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v5_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega644 BOOT_ADR=0xF000 F_CPU=8000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=3 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v6_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega644 BOOT_ADR=0xF000 F_CPU=8000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=0 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v0_cs8_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega644 BOOT_ADR=0xF000 F_CPU=8000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=5 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v1_cs8_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega644 BOOT_ADR=0xF000 F_CPU=8000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=6 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v2_cs8_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega644 BOOT_ADR=0xF000 F_CPU=8000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=2 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v3_cs8_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega644 BOOT_ADR=0xF000 F_CPU=8000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v4_cs8_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega644 BOOT_ADR=0xF000 F_CPU=8000000 SD_CS_PORT=PORTC SD_CS_DDR=DDRC SD_CS_BIT=0 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v5_cs8_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega644 BOOT_ADR=0xF000 F_CPU=8000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=2 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v6_cs8_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega644 BOOT_ADR=0xF000 F_CPU=8000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=2 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v0_cs10_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega644 BOOT_ADR=0xF000 F_CPU=8000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v1_cs10_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega644 BOOT_ADR=0xF000 F_CPU=8000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v2_cs10_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega644 BOOT_ADR=0xF000 F_CPU=8000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v3_cs10_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega644 BOOT_ADR=0xF000 F_CPU=8000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=7 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v4_cs10_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega644 BOOT_ADR=0xF000 F_CPU=8000000 SD_CS_PORT=PORTC SD_CS_DDR=DDRC SD_CS_BIT=2 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v5_cs10_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega644 BOOT_ADR=0xF000 F_CPU=8000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v6_cs10_$(F_CPU)L >> buildlog.txt 2>>&1

make MCU_TARGET=atmega644 BOOT_ADR=0xF000 F_CPU=16000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v0_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega644 BOOT_ADR=0xF000 F_CPU=16000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=0 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v1_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega644 BOOT_ADR=0xF000 F_CPU=16000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=0 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v2_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega644 BOOT_ADR=0xF000 F_CPU=16000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v3_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega644 BOOT_ADR=0xF000 F_CPU=16000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=3 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v4_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega644 BOOT_ADR=0xF000 F_CPU=16000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v5_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega644 BOOT_ADR=0xF000 F_CPU=16000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=3 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v6_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega644 BOOT_ADR=0xF000 F_CPU=16000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=0 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v0_cs8_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega644 BOOT_ADR=0xF000 F_CPU=16000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=5 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v1_cs8_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega644 BOOT_ADR=0xF000 F_CPU=16000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=6 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v2_cs8_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega644 BOOT_ADR=0xF000 F_CPU=16000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=2 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v3_cs8_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega644 BOOT_ADR=0xF000 F_CPU=16000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v4_cs8_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega644 BOOT_ADR=0xF000 F_CPU=16000000 SD_CS_PORT=PORTC SD_CS_DDR=DDRC SD_CS_BIT=0 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v5_cs8_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega644 BOOT_ADR=0xF000 F_CPU=16000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=2 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v6_cs8_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega644 BOOT_ADR=0xF000 F_CPU=16000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=2 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v0_cs10_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega644 BOOT_ADR=0xF000 F_CPU=16000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v1_cs10_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega644 BOOT_ADR=0xF000 F_CPU=16000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v2_cs10_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega644 BOOT_ADR=0xF000 F_CPU=16000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v3_cs10_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega644 BOOT_ADR=0xF000 F_CPU=16000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=7 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v4_cs10_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega644 BOOT_ADR=0xF000 F_CPU=16000000 SD_CS_PORT=PORTC SD_CS_DDR=DDRC SD_CS_BIT=2 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v5_cs10_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega644 BOOT_ADR=0xF000 F_CPU=16000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v6_cs10_$(F_CPU)L >> buildlog.txt 2>>&1

make MCU_TARGET=atmega644 BOOT_ADR=0xF000 F_CPU=20000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v0_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega644 BOOT_ADR=0xF000 F_CPU=20000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=0 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v1_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega644 BOOT_ADR=0xF000 F_CPU=20000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=0 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v2_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega644 BOOT_ADR=0xF000 F_CPU=20000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v3_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega644 BOOT_ADR=0xF000 F_CPU=20000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=3 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v4_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega644 BOOT_ADR=0xF000 F_CPU=20000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v5_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega644 BOOT_ADR=0xF000 F_CPU=20000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=3 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v6_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega644 BOOT_ADR=0xF000 F_CPU=20000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=0 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v0_cs8_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega644 BOOT_ADR=0xF000 F_CPU=20000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=5 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v1_cs8_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega644 BOOT_ADR=0xF000 F_CPU=20000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=6 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v2_cs8_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega644 BOOT_ADR=0xF000 F_CPU=20000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=2 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v3_cs8_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega644 BOOT_ADR=0xF000 F_CPU=20000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v4_cs8_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega644 BOOT_ADR=0xF000 F_CPU=20000000 SD_CS_PORT=PORTC SD_CS_DDR=DDRC SD_CS_BIT=0 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v5_cs8_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega644 BOOT_ADR=0xF000 F_CPU=20000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=2 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v6_cs8_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega644 BOOT_ADR=0xF000 F_CPU=20000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=2 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v0_cs10_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega644 BOOT_ADR=0xF000 F_CPU=20000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v1_cs10_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega644 BOOT_ADR=0xF000 F_CPU=20000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v2_cs10_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega644 BOOT_ADR=0xF000 F_CPU=20000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v3_cs10_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega644 BOOT_ADR=0xF000 F_CPU=20000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=7 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v4_cs10_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega644 BOOT_ADR=0xF000 F_CPU=20000000 SD_CS_PORT=PORTC SD_CS_DDR=DDRC SD_CS_BIT=2 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v5_cs10_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega644 BOOT_ADR=0xF000 F_CPU=20000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v6_cs10_$(F_CPU)L >> buildlog.txt 2>>&1


make MCU_TARGET=atmega644p BOOT_ADR=0xF000 F_CPU=8000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v0_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega644p BOOT_ADR=0xF000 F_CPU=8000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=0 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v1_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega644p BOOT_ADR=0xF000 F_CPU=8000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=0 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v2_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega644p BOOT_ADR=0xF000 F_CPU=8000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v3_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega644p BOOT_ADR=0xF000 F_CPU=8000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=3 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v4_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega644p BOOT_ADR=0xF000 F_CPU=8000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v5_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega644p BOOT_ADR=0xF000 F_CPU=8000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=3 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v6_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega644p BOOT_ADR=0xF000 F_CPU=8000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=0 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v0_cs8_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega644p BOOT_ADR=0xF000 F_CPU=8000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=5 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v1_cs8_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega644p BOOT_ADR=0xF000 F_CPU=8000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=6 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v2_cs8_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega644p BOOT_ADR=0xF000 F_CPU=8000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=2 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v3_cs8_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega644p BOOT_ADR=0xF000 F_CPU=8000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v4_cs8_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega644p BOOT_ADR=0xF000 F_CPU=8000000 SD_CS_PORT=PORTC SD_CS_DDR=DDRC SD_CS_BIT=0 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v5_cs8_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega644p BOOT_ADR=0xF000 F_CPU=8000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=2 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v6_cs8_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega644p BOOT_ADR=0xF000 F_CPU=8000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=2 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v0_cs10_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega644p BOOT_ADR=0xF000 F_CPU=8000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v1_cs10_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega644p BOOT_ADR=0xF000 F_CPU=8000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v2_cs10_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega644p BOOT_ADR=0xF000 F_CPU=8000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v3_cs10_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega644p BOOT_ADR=0xF000 F_CPU=8000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=7 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v4_cs10_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega644p BOOT_ADR=0xF000 F_CPU=8000000 SD_CS_PORT=PORTC SD_CS_DDR=DDRC SD_CS_BIT=2 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v5_cs10_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega644p BOOT_ADR=0xF000 F_CPU=8000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v6_cs10_$(F_CPU)L >> buildlog.txt 2>>&1

make MCU_TARGET=atmega644p BOOT_ADR=0xF000 F_CPU=16000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v0_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega644p BOOT_ADR=0xF000 F_CPU=16000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=0 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v1_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega644p BOOT_ADR=0xF000 F_CPU=16000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=0 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v2_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega644p BOOT_ADR=0xF000 F_CPU=16000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v3_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega644p BOOT_ADR=0xF000 F_CPU=16000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=3 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v4_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega644p BOOT_ADR=0xF000 F_CPU=16000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v5_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega644p BOOT_ADR=0xF000 F_CPU=16000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=3 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v6_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega644p BOOT_ADR=0xF000 F_CPU=16000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=0 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v0_cs8_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega644p BOOT_ADR=0xF000 F_CPU=16000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=5 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v1_cs8_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega644p BOOT_ADR=0xF000 F_CPU=16000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=6 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v2_cs8_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega644p BOOT_ADR=0xF000 F_CPU=16000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=2 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v3_cs8_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega644p BOOT_ADR=0xF000 F_CPU=16000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v4_cs8_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega644p BOOT_ADR=0xF000 F_CPU=16000000 SD_CS_PORT=PORTC SD_CS_DDR=DDRC SD_CS_BIT=0 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v5_cs8_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega644p BOOT_ADR=0xF000 F_CPU=16000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=2 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v6_cs8_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega644p BOOT_ADR=0xF000 F_CPU=16000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=2 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v0_cs10_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega644p BOOT_ADR=0xF000 F_CPU=16000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v1_cs10_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega644p BOOT_ADR=0xF000 F_CPU=16000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v2_cs10_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega644p BOOT_ADR=0xF000 F_CPU=16000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v3_cs10_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega644p BOOT_ADR=0xF000 F_CPU=16000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=7 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v4_cs10_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega644p BOOT_ADR=0xF000 F_CPU=16000000 SD_CS_PORT=PORTC SD_CS_DDR=DDRC SD_CS_BIT=2 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v5_cs10_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega644p BOOT_ADR=0xF000 F_CPU=16000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v6_cs10_$(F_CPU)L >> buildlog.txt 2>>&1

make MCU_TARGET=atmega644p BOOT_ADR=0xF000 F_CPU=20000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v0_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega644p BOOT_ADR=0xF000 F_CPU=20000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=0 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v1_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega644p BOOT_ADR=0xF000 F_CPU=20000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=0 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v2_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega644p BOOT_ADR=0xF000 F_CPU=20000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v3_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega644p BOOT_ADR=0xF000 F_CPU=20000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=3 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v4_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega644p BOOT_ADR=0xF000 F_CPU=20000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v5_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega644p BOOT_ADR=0xF000 F_CPU=20000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=3 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v6_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega644p BOOT_ADR=0xF000 F_CPU=20000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=0 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v0_cs8_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega644p BOOT_ADR=0xF000 F_CPU=20000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=5 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v1_cs8_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega644p BOOT_ADR=0xF000 F_CPU=20000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=6 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v2_cs8_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega644p BOOT_ADR=0xF000 F_CPU=20000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=2 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v3_cs8_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega644p BOOT_ADR=0xF000 F_CPU=20000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v4_cs8_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega644p BOOT_ADR=0xF000 F_CPU=20000000 SD_CS_PORT=PORTC SD_CS_DDR=DDRC SD_CS_BIT=0 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v5_cs8_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega644p BOOT_ADR=0xF000 F_CPU=20000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=2 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v6_cs8_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega644p BOOT_ADR=0xF000 F_CPU=20000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=2 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v0_cs10_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega644p BOOT_ADR=0xF000 F_CPU=20000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v1_cs10_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega644p BOOT_ADR=0xF000 F_CPU=20000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v2_cs10_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega644p BOOT_ADR=0xF000 F_CPU=20000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v3_cs10_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega644p BOOT_ADR=0xF000 F_CPU=20000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=7 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v4_cs10_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega644p BOOT_ADR=0xF000 F_CPU=20000000 SD_CS_PORT=PORTC SD_CS_DDR=DDRC SD_CS_BIT=2 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v5_cs10_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega644p BOOT_ADR=0xF000 F_CPU=20000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v6_cs10_$(F_CPU)L >> buildlog.txt 2>>&1


make MCU_TARGET=atmega644a BOOT_ADR=0xF000 F_CPU=8000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v0_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega644a BOOT_ADR=0xF000 F_CPU=8000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=0 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v1_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega644a BOOT_ADR=0xF000 F_CPU=8000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=0 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v2_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega644a BOOT_ADR=0xF000 F_CPU=8000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v3_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega644a BOOT_ADR=0xF000 F_CPU=8000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=3 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v4_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega644a BOOT_ADR=0xF000 F_CPU=8000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v5_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega644a BOOT_ADR=0xF000 F_CPU=8000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=3 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v6_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega644a BOOT_ADR=0xF000 F_CPU=8000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=0 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v0_cs8_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega644a BOOT_ADR=0xF000 F_CPU=8000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=5 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v1_cs8_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega644a BOOT_ADR=0xF000 F_CPU=8000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=6 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v2_cs8_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega644a BOOT_ADR=0xF000 F_CPU=8000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=2 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v3_cs8_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega644a BOOT_ADR=0xF000 F_CPU=8000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v4_cs8_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega644a BOOT_ADR=0xF000 F_CPU=8000000 SD_CS_PORT=PORTC SD_CS_DDR=DDRC SD_CS_BIT=0 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v5_cs8_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega644a BOOT_ADR=0xF000 F_CPU=8000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=2 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v6_cs8_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega644a BOOT_ADR=0xF000 F_CPU=8000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=2 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v0_cs10_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega644a BOOT_ADR=0xF000 F_CPU=8000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v1_cs10_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega644a BOOT_ADR=0xF000 F_CPU=8000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v2_cs10_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega644a BOOT_ADR=0xF000 F_CPU=8000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v3_cs10_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega644a BOOT_ADR=0xF000 F_CPU=8000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=7 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v4_cs10_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega644a BOOT_ADR=0xF000 F_CPU=8000000 SD_CS_PORT=PORTC SD_CS_DDR=DDRC SD_CS_BIT=2 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v5_cs10_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega644a BOOT_ADR=0xF000 F_CPU=8000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v6_cs10_$(F_CPU)L >> buildlog.txt 2>>&1

make MCU_TARGET=atmega644a BOOT_ADR=0xF000 F_CPU=16000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v0_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega644a BOOT_ADR=0xF000 F_CPU=16000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=0 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v1_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega644a BOOT_ADR=0xF000 F_CPU=16000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=0 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v2_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega644a BOOT_ADR=0xF000 F_CPU=16000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v3_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega644a BOOT_ADR=0xF000 F_CPU=16000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=3 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v4_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega644a BOOT_ADR=0xF000 F_CPU=16000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v5_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega644a BOOT_ADR=0xF000 F_CPU=16000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=3 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v6_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega644a BOOT_ADR=0xF000 F_CPU=16000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=0 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v0_cs8_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega644a BOOT_ADR=0xF000 F_CPU=16000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=5 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v1_cs8_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega644a BOOT_ADR=0xF000 F_CPU=16000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=6 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v2_cs8_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega644a BOOT_ADR=0xF000 F_CPU=16000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=2 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v3_cs8_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega644a BOOT_ADR=0xF000 F_CPU=16000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v4_cs8_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega644a BOOT_ADR=0xF000 F_CPU=16000000 SD_CS_PORT=PORTC SD_CS_DDR=DDRC SD_CS_BIT=0 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v5_cs8_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega644a BOOT_ADR=0xF000 F_CPU=16000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=2 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v6_cs8_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega644a BOOT_ADR=0xF000 F_CPU=16000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=2 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v0_cs10_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega644a BOOT_ADR=0xF000 F_CPU=16000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v1_cs10_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega644a BOOT_ADR=0xF000 F_CPU=16000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v2_cs10_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega644a BOOT_ADR=0xF000 F_CPU=16000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v3_cs10_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega644a BOOT_ADR=0xF000 F_CPU=16000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=7 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v4_cs10_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega644a BOOT_ADR=0xF000 F_CPU=16000000 SD_CS_PORT=PORTC SD_CS_DDR=DDRC SD_CS_BIT=2 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v5_cs10_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega644a BOOT_ADR=0xF000 F_CPU=16000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v6_cs10_$(F_CPU)L >> buildlog.txt 2>>&1

make MCU_TARGET=atmega644a BOOT_ADR=0xF000 F_CPU=20000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v0_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega644a BOOT_ADR=0xF000 F_CPU=20000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=0 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v1_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega644a BOOT_ADR=0xF000 F_CPU=20000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=0 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v2_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega644a BOOT_ADR=0xF000 F_CPU=20000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v3_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega644a BOOT_ADR=0xF000 F_CPU=20000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=3 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v4_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega644a BOOT_ADR=0xF000 F_CPU=20000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v5_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega644a BOOT_ADR=0xF000 F_CPU=20000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=3 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v6_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega644a BOOT_ADR=0xF000 F_CPU=20000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=0 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v0_cs8_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega644a BOOT_ADR=0xF000 F_CPU=20000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=5 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v1_cs8_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega644a BOOT_ADR=0xF000 F_CPU=20000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=6 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v2_cs8_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega644a BOOT_ADR=0xF000 F_CPU=20000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=2 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v3_cs8_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega644a BOOT_ADR=0xF000 F_CPU=20000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v4_cs8_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega644a BOOT_ADR=0xF000 F_CPU=20000000 SD_CS_PORT=PORTC SD_CS_DDR=DDRC SD_CS_BIT=0 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v5_cs8_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega644a BOOT_ADR=0xF000 F_CPU=20000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=2 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v6_cs8_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega644a BOOT_ADR=0xF000 F_CPU=20000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=2 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v0_cs10_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega644a BOOT_ADR=0xF000 F_CPU=20000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v1_cs10_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega644a BOOT_ADR=0xF000 F_CPU=20000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v2_cs10_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega644a BOOT_ADR=0xF000 F_CPU=20000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v3_cs10_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega644a BOOT_ADR=0xF000 F_CPU=20000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=7 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v4_cs10_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega644a BOOT_ADR=0xF000 F_CPU=20000000 SD_CS_PORT=PORTC SD_CS_DDR=DDRC SD_CS_BIT=2 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v5_cs10_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega644a BOOT_ADR=0xF000 F_CPU=20000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v6_cs10_$(F_CPU)L >> buildlog.txt 2>>&1


make MCU_TARGET=atmega644pa BOOT_ADR=0xF000 F_CPU=8000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v0_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega644pa BOOT_ADR=0xF000 F_CPU=8000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=0 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v1_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega644pa BOOT_ADR=0xF000 F_CPU=8000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=0 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v2_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega644pa BOOT_ADR=0xF000 F_CPU=8000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v3_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega644pa BOOT_ADR=0xF000 F_CPU=8000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=3 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v4_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega644pa BOOT_ADR=0xF000 F_CPU=8000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v5_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega644pa BOOT_ADR=0xF000 F_CPU=8000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=3 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v6_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega644pa BOOT_ADR=0xF000 F_CPU=8000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=0 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v0_cs8_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega644pa BOOT_ADR=0xF000 F_CPU=8000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=5 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v1_cs8_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega644pa BOOT_ADR=0xF000 F_CPU=8000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=6 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v2_cs8_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega644pa BOOT_ADR=0xF000 F_CPU=8000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=2 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v3_cs8_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega644pa BOOT_ADR=0xF000 F_CPU=8000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v4_cs8_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega644pa BOOT_ADR=0xF000 F_CPU=8000000 SD_CS_PORT=PORTC SD_CS_DDR=DDRC SD_CS_BIT=0 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v5_cs8_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega644pa BOOT_ADR=0xF000 F_CPU=8000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=2 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v6_cs8_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega644pa BOOT_ADR=0xF000 F_CPU=8000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=2 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v0_cs10_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega644pa BOOT_ADR=0xF000 F_CPU=8000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v1_cs10_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega644pa BOOT_ADR=0xF000 F_CPU=8000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v2_cs10_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega644pa BOOT_ADR=0xF000 F_CPU=8000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v3_cs10_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega644pa BOOT_ADR=0xF000 F_CPU=8000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=7 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v4_cs10_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega644pa BOOT_ADR=0xF000 F_CPU=8000000 SD_CS_PORT=PORTC SD_CS_DDR=DDRC SD_CS_BIT=2 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v5_cs10_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega644pa BOOT_ADR=0xF000 F_CPU=8000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v6_cs10_$(F_CPU)L >> buildlog.txt 2>>&1

make MCU_TARGET=atmega644pa BOOT_ADR=0xF000 F_CPU=16000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v0_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega644pa BOOT_ADR=0xF000 F_CPU=16000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=0 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v1_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega644pa BOOT_ADR=0xF000 F_CPU=16000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=0 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v2_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega644pa BOOT_ADR=0xF000 F_CPU=16000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v3_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega644pa BOOT_ADR=0xF000 F_CPU=16000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=3 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v4_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega644pa BOOT_ADR=0xF000 F_CPU=16000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v5_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega644pa BOOT_ADR=0xF000 F_CPU=16000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=3 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v6_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega644pa BOOT_ADR=0xF000 F_CPU=16000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=0 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v0_cs8_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega644pa BOOT_ADR=0xF000 F_CPU=16000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=5 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v1_cs8_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega644pa BOOT_ADR=0xF000 F_CPU=16000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=6 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v2_cs8_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega644pa BOOT_ADR=0xF000 F_CPU=16000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=2 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v3_cs8_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega644pa BOOT_ADR=0xF000 F_CPU=16000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v4_cs8_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega644pa BOOT_ADR=0xF000 F_CPU=16000000 SD_CS_PORT=PORTC SD_CS_DDR=DDRC SD_CS_BIT=0 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v5_cs8_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega644pa BOOT_ADR=0xF000 F_CPU=16000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=2 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v6_cs8_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega644pa BOOT_ADR=0xF000 F_CPU=16000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=2 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v0_cs10_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega644pa BOOT_ADR=0xF000 F_CPU=16000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v1_cs10_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega644pa BOOT_ADR=0xF000 F_CPU=16000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v2_cs10_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega644pa BOOT_ADR=0xF000 F_CPU=16000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v3_cs10_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega644pa BOOT_ADR=0xF000 F_CPU=16000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=7 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v4_cs10_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega644pa BOOT_ADR=0xF000 F_CPU=16000000 SD_CS_PORT=PORTC SD_CS_DDR=DDRC SD_CS_BIT=2 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v5_cs10_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega644pa BOOT_ADR=0xF000 F_CPU=16000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v6_cs10_$(F_CPU)L >> buildlog.txt 2>>&1

make MCU_TARGET=atmega644pa BOOT_ADR=0xF000 F_CPU=20000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v0_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega644pa BOOT_ADR=0xF000 F_CPU=20000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=0 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v1_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega644pa BOOT_ADR=0xF000 F_CPU=20000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=0 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v2_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega644pa BOOT_ADR=0xF000 F_CPU=20000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v3_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega644pa BOOT_ADR=0xF000 F_CPU=20000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=3 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v4_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega644pa BOOT_ADR=0xF000 F_CPU=20000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v5_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega644pa BOOT_ADR=0xF000 F_CPU=20000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=3 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v6_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega644pa BOOT_ADR=0xF000 F_CPU=20000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=0 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v0_cs8_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega644pa BOOT_ADR=0xF000 F_CPU=20000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=5 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v1_cs8_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega644pa BOOT_ADR=0xF000 F_CPU=20000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=6 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v2_cs8_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega644pa BOOT_ADR=0xF000 F_CPU=20000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=2 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v3_cs8_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega644pa BOOT_ADR=0xF000 F_CPU=20000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v4_cs8_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega644pa BOOT_ADR=0xF000 F_CPU=20000000 SD_CS_PORT=PORTC SD_CS_DDR=DDRC SD_CS_BIT=0 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v5_cs8_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega644pa BOOT_ADR=0xF000 F_CPU=20000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=2 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v6_cs8_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega644pa BOOT_ADR=0xF000 F_CPU=20000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=2 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v0_cs10_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega644pa BOOT_ADR=0xF000 F_CPU=20000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v1_cs10_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega644pa BOOT_ADR=0xF000 F_CPU=20000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v2_cs10_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega644pa BOOT_ADR=0xF000 F_CPU=20000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v3_cs10_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega644pa BOOT_ADR=0xF000 F_CPU=20000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=7 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v4_cs10_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega644pa BOOT_ADR=0xF000 F_CPU=20000000 SD_CS_PORT=PORTC SD_CS_DDR=DDRC SD_CS_BIT=2 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v5_cs10_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega644pa BOOT_ADR=0xF000 F_CPU=20000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v6_cs10_$(F_CPU)L >> buildlog.txt 2>>&1


make MCU_TARGET=atmega324a BOOT_ADR=0x7000 F_CPU=8000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v0_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega324a BOOT_ADR=0x7000 F_CPU=8000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=0 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v1_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega324a BOOT_ADR=0x7000 F_CPU=8000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=0 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v2_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega324a BOOT_ADR=0x7000 F_CPU=8000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v3_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega324a BOOT_ADR=0x7000 F_CPU=8000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=3 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v4_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega324a BOOT_ADR=0x7000 F_CPU=8000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v5_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega324a BOOT_ADR=0x7000 F_CPU=8000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=3 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v6_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega324a BOOT_ADR=0x7000 F_CPU=8000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=0 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v0_cs8_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega324a BOOT_ADR=0x7000 F_CPU=8000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=5 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v1_cs8_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega324a BOOT_ADR=0x7000 F_CPU=8000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=6 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v2_cs8_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega324a BOOT_ADR=0x7000 F_CPU=8000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=2 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v3_cs8_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega324a BOOT_ADR=0x7000 F_CPU=8000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v4_cs8_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega324a BOOT_ADR=0x7000 F_CPU=8000000 SD_CS_PORT=PORTC SD_CS_DDR=DDRC SD_CS_BIT=0 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v5_cs8_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega324a BOOT_ADR=0x7000 F_CPU=8000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=2 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v6_cs8_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega324a BOOT_ADR=0x7000 F_CPU=8000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=2 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v0_cs10_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega324a BOOT_ADR=0x7000 F_CPU=8000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v1_cs10_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega324a BOOT_ADR=0x7000 F_CPU=8000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v2_cs10_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega324a BOOT_ADR=0x7000 F_CPU=8000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v3_cs10_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega324a BOOT_ADR=0x7000 F_CPU=8000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=7 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v4_cs10_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega324a BOOT_ADR=0x7000 F_CPU=8000000 SD_CS_PORT=PORTC SD_CS_DDR=DDRC SD_CS_BIT=2 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v5_cs10_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega324a BOOT_ADR=0x7000 F_CPU=8000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v6_cs10_$(F_CPU)L >> buildlog.txt 2>>&1

make MCU_TARGET=atmega324a BOOT_ADR=0x7000 F_CPU=16000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v0_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega324a BOOT_ADR=0x7000 F_CPU=16000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=0 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v1_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega324a BOOT_ADR=0x7000 F_CPU=16000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=0 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v2_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega324a BOOT_ADR=0x7000 F_CPU=16000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v3_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega324a BOOT_ADR=0x7000 F_CPU=16000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=3 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v4_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega324a BOOT_ADR=0x7000 F_CPU=16000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v5_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega324a BOOT_ADR=0x7000 F_CPU=16000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=3 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v6_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega324a BOOT_ADR=0x7000 F_CPU=16000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=0 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v0_cs8_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega324a BOOT_ADR=0x7000 F_CPU=16000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=5 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v1_cs8_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega324a BOOT_ADR=0x7000 F_CPU=16000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=6 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v2_cs8_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega324a BOOT_ADR=0x7000 F_CPU=16000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=2 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v3_cs8_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega324a BOOT_ADR=0x7000 F_CPU=16000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v4_cs8_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega324a BOOT_ADR=0x7000 F_CPU=16000000 SD_CS_PORT=PORTC SD_CS_DDR=DDRC SD_CS_BIT=0 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v5_cs8_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega324a BOOT_ADR=0x7000 F_CPU=16000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=2 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v6_cs8_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega324a BOOT_ADR=0x7000 F_CPU=16000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=2 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v0_cs10_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega324a BOOT_ADR=0x7000 F_CPU=16000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v1_cs10_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega324a BOOT_ADR=0x7000 F_CPU=16000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v2_cs10_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega324a BOOT_ADR=0x7000 F_CPU=16000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v3_cs10_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega324a BOOT_ADR=0x7000 F_CPU=16000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=7 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v4_cs10_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega324a BOOT_ADR=0x7000 F_CPU=16000000 SD_CS_PORT=PORTC SD_CS_DDR=DDRC SD_CS_BIT=2 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v5_cs10_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega324a BOOT_ADR=0x7000 F_CPU=16000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v6_cs10_$(F_CPU)L >> buildlog.txt 2>>&1

make MCU_TARGET=atmega324a BOOT_ADR=0x7000 F_CPU=20000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v0_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega324a BOOT_ADR=0x7000 F_CPU=20000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=0 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v1_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega324a BOOT_ADR=0x7000 F_CPU=20000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=0 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v2_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega324a BOOT_ADR=0x7000 F_CPU=20000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v3_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega324a BOOT_ADR=0x7000 F_CPU=20000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=3 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v4_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega324a BOOT_ADR=0x7000 F_CPU=20000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v5_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega324a BOOT_ADR=0x7000 F_CPU=20000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=3 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v6_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega324a BOOT_ADR=0x7000 F_CPU=20000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=0 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v0_cs8_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega324a BOOT_ADR=0x7000 F_CPU=20000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=5 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v1_cs8_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega324a BOOT_ADR=0x7000 F_CPU=20000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=6 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v2_cs8_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega324a BOOT_ADR=0x7000 F_CPU=20000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=2 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v3_cs8_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega324a BOOT_ADR=0x7000 F_CPU=20000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v4_cs8_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega324a BOOT_ADR=0x7000 F_CPU=20000000 SD_CS_PORT=PORTC SD_CS_DDR=DDRC SD_CS_BIT=0 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v5_cs8_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega324a BOOT_ADR=0x7000 F_CPU=20000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=2 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v6_cs8_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega324a BOOT_ADR=0x7000 F_CPU=20000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=2 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v0_cs10_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega324a BOOT_ADR=0x7000 F_CPU=20000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v1_cs10_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega324a BOOT_ADR=0x7000 F_CPU=20000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v2_cs10_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega324a BOOT_ADR=0x7000 F_CPU=20000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v3_cs10_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega324a BOOT_ADR=0x7000 F_CPU=20000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=7 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v4_cs10_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega324a BOOT_ADR=0x7000 F_CPU=20000000 SD_CS_PORT=PORTC SD_CS_DDR=DDRC SD_CS_BIT=2 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v5_cs10_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega324a BOOT_ADR=0x7000 F_CPU=20000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v6_cs10_$(F_CPU)L >> buildlog.txt 2>>&1


make MCU_TARGET=atmega324p BOOT_ADR=0x7000 F_CPU=8000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v0_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega324p BOOT_ADR=0x7000 F_CPU=8000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=0 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v1_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega324p BOOT_ADR=0x7000 F_CPU=8000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=0 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v2_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega324p BOOT_ADR=0x7000 F_CPU=8000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v3_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega324p BOOT_ADR=0x7000 F_CPU=8000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=3 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v4_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega324p BOOT_ADR=0x7000 F_CPU=8000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v5_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega324p BOOT_ADR=0x7000 F_CPU=8000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=3 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v6_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega324p BOOT_ADR=0x7000 F_CPU=8000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=0 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v0_cs8_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega324p BOOT_ADR=0x7000 F_CPU=8000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=5 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v1_cs8_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega324p BOOT_ADR=0x7000 F_CPU=8000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=6 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v2_cs8_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega324p BOOT_ADR=0x7000 F_CPU=8000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=2 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v3_cs8_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega324p BOOT_ADR=0x7000 F_CPU=8000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v4_cs8_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega324p BOOT_ADR=0x7000 F_CPU=8000000 SD_CS_PORT=PORTC SD_CS_DDR=DDRC SD_CS_BIT=0 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v5_cs8_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega324p BOOT_ADR=0x7000 F_CPU=8000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=2 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v6_cs8_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega324p BOOT_ADR=0x7000 F_CPU=8000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=2 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v0_cs10_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega324p BOOT_ADR=0x7000 F_CPU=8000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v1_cs10_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega324p BOOT_ADR=0x7000 F_CPU=8000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v2_cs10_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega324p BOOT_ADR=0x7000 F_CPU=8000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v3_cs10_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega324p BOOT_ADR=0x7000 F_CPU=8000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=7 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v4_cs10_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega324p BOOT_ADR=0x7000 F_CPU=8000000 SD_CS_PORT=PORTC SD_CS_DDR=DDRC SD_CS_BIT=2 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v5_cs10_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega324p BOOT_ADR=0x7000 F_CPU=8000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v6_cs10_$(F_CPU)L >> buildlog.txt 2>>&1

make MCU_TARGET=atmega324p BOOT_ADR=0x7000 F_CPU=16000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v0_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega324p BOOT_ADR=0x7000 F_CPU=16000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=0 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v1_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega324p BOOT_ADR=0x7000 F_CPU=16000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=0 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v2_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega324p BOOT_ADR=0x7000 F_CPU=16000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v3_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega324p BOOT_ADR=0x7000 F_CPU=16000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=3 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v4_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega324p BOOT_ADR=0x7000 F_CPU=16000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v5_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega324p BOOT_ADR=0x7000 F_CPU=16000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=3 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v6_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega324p BOOT_ADR=0x7000 F_CPU=16000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=0 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v0_cs8_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega324p BOOT_ADR=0x7000 F_CPU=16000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=5 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v1_cs8_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega324p BOOT_ADR=0x7000 F_CPU=16000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=6 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v2_cs8_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega324p BOOT_ADR=0x7000 F_CPU=16000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=2 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v3_cs8_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega324p BOOT_ADR=0x7000 F_CPU=16000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v4_cs8_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega324p BOOT_ADR=0x7000 F_CPU=16000000 SD_CS_PORT=PORTC SD_CS_DDR=DDRC SD_CS_BIT=0 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v5_cs8_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega324p BOOT_ADR=0x7000 F_CPU=16000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=2 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v6_cs8_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega324p BOOT_ADR=0x7000 F_CPU=16000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=2 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v0_cs10_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega324p BOOT_ADR=0x7000 F_CPU=16000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v1_cs10_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega324p BOOT_ADR=0x7000 F_CPU=16000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v2_cs10_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega324p BOOT_ADR=0x7000 F_CPU=16000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v3_cs10_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega324p BOOT_ADR=0x7000 F_CPU=16000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=7 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v4_cs10_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega324p BOOT_ADR=0x7000 F_CPU=16000000 SD_CS_PORT=PORTC SD_CS_DDR=DDRC SD_CS_BIT=2 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v5_cs10_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega324p BOOT_ADR=0x7000 F_CPU=16000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v6_cs10_$(F_CPU)L >> buildlog.txt 2>>&1

make MCU_TARGET=atmega324p BOOT_ADR=0x7000 F_CPU=20000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v0_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega324p BOOT_ADR=0x7000 F_CPU=20000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=0 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v1_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega324p BOOT_ADR=0x7000 F_CPU=20000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=0 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v2_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega324p BOOT_ADR=0x7000 F_CPU=20000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v3_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega324p BOOT_ADR=0x7000 F_CPU=20000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=3 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v4_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega324p BOOT_ADR=0x7000 F_CPU=20000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v5_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega324p BOOT_ADR=0x7000 F_CPU=20000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=3 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v6_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega324p BOOT_ADR=0x7000 F_CPU=20000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=0 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v0_cs8_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega324p BOOT_ADR=0x7000 F_CPU=20000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=5 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v1_cs8_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega324p BOOT_ADR=0x7000 F_CPU=20000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=6 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v2_cs8_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega324p BOOT_ADR=0x7000 F_CPU=20000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=2 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v3_cs8_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega324p BOOT_ADR=0x7000 F_CPU=20000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v4_cs8_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega324p BOOT_ADR=0x7000 F_CPU=20000000 SD_CS_PORT=PORTC SD_CS_DDR=DDRC SD_CS_BIT=0 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v5_cs8_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega324p BOOT_ADR=0x7000 F_CPU=20000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=2 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v6_cs8_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega324p BOOT_ADR=0x7000 F_CPU=20000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=2 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v0_cs10_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega324p BOOT_ADR=0x7000 F_CPU=20000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v1_cs10_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega324p BOOT_ADR=0x7000 F_CPU=20000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v2_cs10_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega324p BOOT_ADR=0x7000 F_CPU=20000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v3_cs10_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega324p BOOT_ADR=0x7000 F_CPU=20000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=7 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v4_cs10_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega324p BOOT_ADR=0x7000 F_CPU=20000000 SD_CS_PORT=PORTC SD_CS_DDR=DDRC SD_CS_BIT=2 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v5_cs10_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega324p BOOT_ADR=0x7000 F_CPU=20000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v6_cs10_$(F_CPU)L >> buildlog.txt 2>>&1


make MCU_TARGET=atmega324pa BOOT_ADR=0x7000 F_CPU=8000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v0_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega324pa BOOT_ADR=0x7000 F_CPU=8000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=0 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v1_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega324pa BOOT_ADR=0x7000 F_CPU=8000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=0 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v2_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega324pa BOOT_ADR=0x7000 F_CPU=8000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v3_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega324pa BOOT_ADR=0x7000 F_CPU=8000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=3 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v4_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega324pa BOOT_ADR=0x7000 F_CPU=8000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v5_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega324pa BOOT_ADR=0x7000 F_CPU=8000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=3 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v6_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega324pa BOOT_ADR=0x7000 F_CPU=8000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=0 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v0_cs8_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega324pa BOOT_ADR=0x7000 F_CPU=8000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=5 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v1_cs8_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega324pa BOOT_ADR=0x7000 F_CPU=8000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=6 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v2_cs8_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega324pa BOOT_ADR=0x7000 F_CPU=8000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=2 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v3_cs8_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega324pa BOOT_ADR=0x7000 F_CPU=8000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v4_cs8_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega324pa BOOT_ADR=0x7000 F_CPU=8000000 SD_CS_PORT=PORTC SD_CS_DDR=DDRC SD_CS_BIT=0 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v5_cs8_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega324pa BOOT_ADR=0x7000 F_CPU=8000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=2 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v6_cs8_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega324pa BOOT_ADR=0x7000 F_CPU=8000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=2 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v0_cs10_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega324pa BOOT_ADR=0x7000 F_CPU=8000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v1_cs10_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega324pa BOOT_ADR=0x7000 F_CPU=8000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v2_cs10_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega324pa BOOT_ADR=0x7000 F_CPU=8000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v3_cs10_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega324pa BOOT_ADR=0x7000 F_CPU=8000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=7 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v4_cs10_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega324pa BOOT_ADR=0x7000 F_CPU=8000000 SD_CS_PORT=PORTC SD_CS_DDR=DDRC SD_CS_BIT=2 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v5_cs10_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega324pa BOOT_ADR=0x7000 F_CPU=8000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v6_cs10_$(F_CPU)L >> buildlog.txt 2>>&1

make MCU_TARGET=atmega324pa BOOT_ADR=0x7000 F_CPU=16000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v0_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega324pa BOOT_ADR=0x7000 F_CPU=16000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=0 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v1_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega324pa BOOT_ADR=0x7000 F_CPU=16000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=0 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v2_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega324pa BOOT_ADR=0x7000 F_CPU=16000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v3_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega324pa BOOT_ADR=0x7000 F_CPU=16000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=3 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v4_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega324pa BOOT_ADR=0x7000 F_CPU=16000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v5_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega324pa BOOT_ADR=0x7000 F_CPU=16000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=3 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v6_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega324pa BOOT_ADR=0x7000 F_CPU=16000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=0 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v0_cs8_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega324pa BOOT_ADR=0x7000 F_CPU=16000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=5 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v1_cs8_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega324pa BOOT_ADR=0x7000 F_CPU=16000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=6 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v2_cs8_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega324pa BOOT_ADR=0x7000 F_CPU=16000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=2 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v3_cs8_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega324pa BOOT_ADR=0x7000 F_CPU=16000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v4_cs8_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega324pa BOOT_ADR=0x7000 F_CPU=16000000 SD_CS_PORT=PORTC SD_CS_DDR=DDRC SD_CS_BIT=0 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v5_cs8_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega324pa BOOT_ADR=0x7000 F_CPU=16000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=2 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v6_cs8_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega324pa BOOT_ADR=0x7000 F_CPU=16000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=2 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v0_cs10_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega324pa BOOT_ADR=0x7000 F_CPU=16000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v1_cs10_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega324pa BOOT_ADR=0x7000 F_CPU=16000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v2_cs10_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega324pa BOOT_ADR=0x7000 F_CPU=16000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v3_cs10_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega324pa BOOT_ADR=0x7000 F_CPU=16000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=7 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v4_cs10_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega324pa BOOT_ADR=0x7000 F_CPU=16000000 SD_CS_PORT=PORTC SD_CS_DDR=DDRC SD_CS_BIT=2 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v5_cs10_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega324pa BOOT_ADR=0x7000 F_CPU=16000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v6_cs10_$(F_CPU)L >> buildlog.txt 2>>&1

make MCU_TARGET=atmega324pa BOOT_ADR=0x7000 F_CPU=20000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v0_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega324pa BOOT_ADR=0x7000 F_CPU=20000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=0 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v1_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega324pa BOOT_ADR=0x7000 F_CPU=20000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=0 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v2_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega324pa BOOT_ADR=0x7000 F_CPU=20000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v3_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega324pa BOOT_ADR=0x7000 F_CPU=20000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=3 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v4_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega324pa BOOT_ADR=0x7000 F_CPU=20000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v5_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega324pa BOOT_ADR=0x7000 F_CPU=20000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=3 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v6_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega324pa BOOT_ADR=0x7000 F_CPU=20000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=0 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v0_cs8_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega324pa BOOT_ADR=0x7000 F_CPU=20000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=5 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v1_cs8_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega324pa BOOT_ADR=0x7000 F_CPU=20000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=6 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v2_cs8_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega324pa BOOT_ADR=0x7000 F_CPU=20000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=2 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v3_cs8_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega324pa BOOT_ADR=0x7000 F_CPU=20000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v4_cs8_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega324pa BOOT_ADR=0x7000 F_CPU=20000000 SD_CS_PORT=PORTC SD_CS_DDR=DDRC SD_CS_BIT=0 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v5_cs8_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega324pa BOOT_ADR=0x7000 F_CPU=20000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=2 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v6_cs8_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega324pa BOOT_ADR=0x7000 F_CPU=20000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=2 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v0_cs10_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega324pa BOOT_ADR=0x7000 F_CPU=20000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v1_cs10_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega324pa BOOT_ADR=0x7000 F_CPU=20000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v2_cs10_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega324pa BOOT_ADR=0x7000 F_CPU=20000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v3_cs10_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega324pa BOOT_ADR=0x7000 F_CPU=20000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=7 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v4_cs10_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega324pa BOOT_ADR=0x7000 F_CPU=20000000 SD_CS_PORT=PORTC SD_CS_DDR=DDRC SD_CS_BIT=2 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v5_cs10_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega324pa BOOT_ADR=0x7000 F_CPU=20000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v6_cs10_$(F_CPU)L >> buildlog.txt 2>>&1


make MCU_TARGET=atmega32 BOOT_ADR=0x7000 F_CPU=8000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v0_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega32 BOOT_ADR=0x7000 F_CPU=8000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=0 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v1_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega32 BOOT_ADR=0x7000 F_CPU=8000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=0 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v2_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega32 BOOT_ADR=0x7000 F_CPU=8000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v3_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega32 BOOT_ADR=0x7000 F_CPU=8000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=3 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v4_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega32 BOOT_ADR=0x7000 F_CPU=8000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v5_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega32 BOOT_ADR=0x7000 F_CPU=8000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=3 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v6_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega32 BOOT_ADR=0x7000 F_CPU=8000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=0 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v0_cs8_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega32 BOOT_ADR=0x7000 F_CPU=8000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=5 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v1_cs8_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega32 BOOT_ADR=0x7000 F_CPU=8000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=6 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v2_cs8_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega32 BOOT_ADR=0x7000 F_CPU=8000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=2 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v3_cs8_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega32 BOOT_ADR=0x7000 F_CPU=8000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v4_cs8_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega32 BOOT_ADR=0x7000 F_CPU=8000000 SD_CS_PORT=PORTC SD_CS_DDR=DDRC SD_CS_BIT=0 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v5_cs8_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega32 BOOT_ADR=0x7000 F_CPU=8000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=2 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v6_cs8_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega32 BOOT_ADR=0x7000 F_CPU=8000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=2 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v0_cs10_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega32 BOOT_ADR=0x7000 F_CPU=8000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v1_cs10_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega32 BOOT_ADR=0x7000 F_CPU=8000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v2_cs10_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega32 BOOT_ADR=0x7000 F_CPU=8000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v3_cs10_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega32 BOOT_ADR=0x7000 F_CPU=8000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=7 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v4_cs10_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega32 BOOT_ADR=0x7000 F_CPU=8000000 SD_CS_PORT=PORTC SD_CS_DDR=DDRC SD_CS_BIT=2 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v5_cs10_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega32 BOOT_ADR=0x7000 F_CPU=8000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v6_cs10_$(F_CPU)L >> buildlog.txt 2>>&1

make MCU_TARGET=atmega32 BOOT_ADR=0x7000 F_CPU=16000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v0_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega32 BOOT_ADR=0x7000 F_CPU=16000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=0 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v1_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega32 BOOT_ADR=0x7000 F_CPU=16000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=0 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v2_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega32 BOOT_ADR=0x7000 F_CPU=16000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v3_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega32 BOOT_ADR=0x7000 F_CPU=16000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=3 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v4_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega32 BOOT_ADR=0x7000 F_CPU=16000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v5_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega32 BOOT_ADR=0x7000 F_CPU=16000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=3 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v6_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega32 BOOT_ADR=0x7000 F_CPU=16000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=0 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v0_cs8_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega32 BOOT_ADR=0x7000 F_CPU=16000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=5 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v1_cs8_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega32 BOOT_ADR=0x7000 F_CPU=16000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=6 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v2_cs8_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega32 BOOT_ADR=0x7000 F_CPU=16000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=2 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v3_cs8_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega32 BOOT_ADR=0x7000 F_CPU=16000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v4_cs8_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega32 BOOT_ADR=0x7000 F_CPU=16000000 SD_CS_PORT=PORTC SD_CS_DDR=DDRC SD_CS_BIT=0 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v5_cs8_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega32 BOOT_ADR=0x7000 F_CPU=16000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=2 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v6_cs8_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega32 BOOT_ADR=0x7000 F_CPU=16000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=2 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v0_cs10_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega32 BOOT_ADR=0x7000 F_CPU=16000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v1_cs10_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega32 BOOT_ADR=0x7000 F_CPU=16000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v2_cs10_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega32 BOOT_ADR=0x7000 F_CPU=16000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v3_cs10_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega32 BOOT_ADR=0x7000 F_CPU=16000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=7 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v4_cs10_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega32 BOOT_ADR=0x7000 F_CPU=16000000 SD_CS_PORT=PORTC SD_CS_DDR=DDRC SD_CS_BIT=2 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v5_cs10_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega32 BOOT_ADR=0x7000 F_CPU=16000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v6_cs10_$(F_CPU)L >> buildlog.txt 2>>&1


make MCU_TARGET=atmega32a BOOT_ADR=0x7000 F_CPU=8000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v0_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega32a BOOT_ADR=0x7000 F_CPU=8000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=0 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v1_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega32a BOOT_ADR=0x7000 F_CPU=8000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=0 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v2_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega32a BOOT_ADR=0x7000 F_CPU=8000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v3_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega32a BOOT_ADR=0x7000 F_CPU=8000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=3 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v4_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega32a BOOT_ADR=0x7000 F_CPU=8000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v5_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega32a BOOT_ADR=0x7000 F_CPU=8000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=3 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v6_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega32a BOOT_ADR=0x7000 F_CPU=8000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=0 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v0_cs8_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega32a BOOT_ADR=0x7000 F_CPU=8000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=5 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v1_cs8_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega32a BOOT_ADR=0x7000 F_CPU=8000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=6 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v2_cs8_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega32a BOOT_ADR=0x7000 F_CPU=8000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=2 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v3_cs8_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega32a BOOT_ADR=0x7000 F_CPU=8000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v4_cs8_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega32a BOOT_ADR=0x7000 F_CPU=8000000 SD_CS_PORT=PORTC SD_CS_DDR=DDRC SD_CS_BIT=0 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v5_cs8_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega32a BOOT_ADR=0x7000 F_CPU=8000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=2 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v6_cs8_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega32a BOOT_ADR=0x7000 F_CPU=8000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=2 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v0_cs10_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega32a BOOT_ADR=0x7000 F_CPU=8000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v1_cs10_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega32a BOOT_ADR=0x7000 F_CPU=8000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v2_cs10_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega32a BOOT_ADR=0x7000 F_CPU=8000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v3_cs10_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega32a BOOT_ADR=0x7000 F_CPU=8000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=7 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v4_cs10_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega32a BOOT_ADR=0x7000 F_CPU=8000000 SD_CS_PORT=PORTC SD_CS_DDR=DDRC SD_CS_BIT=2 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v5_cs10_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega32a BOOT_ADR=0x7000 F_CPU=8000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v6_cs10_$(F_CPU)L >> buildlog.txt 2>>&1

make MCU_TARGET=atmega32a BOOT_ADR=0x7000 F_CPU=16000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v0_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega32a BOOT_ADR=0x7000 F_CPU=16000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=0 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v1_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega32a BOOT_ADR=0x7000 F_CPU=16000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=0 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v2_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega32a BOOT_ADR=0x7000 F_CPU=16000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v3_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega32a BOOT_ADR=0x7000 F_CPU=16000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=3 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v4_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega32a BOOT_ADR=0x7000 F_CPU=16000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v5_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega32a BOOT_ADR=0x7000 F_CPU=16000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=3 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v6_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega32a BOOT_ADR=0x7000 F_CPU=16000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=0 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v0_cs8_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega32a BOOT_ADR=0x7000 F_CPU=16000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=5 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v1_cs8_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega32a BOOT_ADR=0x7000 F_CPU=16000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=6 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v2_cs8_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega32a BOOT_ADR=0x7000 F_CPU=16000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=2 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v3_cs8_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega32a BOOT_ADR=0x7000 F_CPU=16000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v4_cs8_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega32a BOOT_ADR=0x7000 F_CPU=16000000 SD_CS_PORT=PORTC SD_CS_DDR=DDRC SD_CS_BIT=0 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v5_cs8_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega32a BOOT_ADR=0x7000 F_CPU=16000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=2 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v6_cs8_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega32a BOOT_ADR=0x7000 F_CPU=16000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=2 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v0_cs10_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega32a BOOT_ADR=0x7000 F_CPU=16000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v1_cs10_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega32a BOOT_ADR=0x7000 F_CPU=16000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v2_cs10_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega32a BOOT_ADR=0x7000 F_CPU=16000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v3_cs10_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega32a BOOT_ADR=0x7000 F_CPU=16000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=7 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v4_cs10_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega32a BOOT_ADR=0x7000 F_CPU=16000000 SD_CS_PORT=PORTC SD_CS_DDR=DDRC SD_CS_BIT=2 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v5_cs10_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega32a BOOT_ADR=0x7000 F_CPU=16000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v6_cs10_$(F_CPU)L >> buildlog.txt 2>>&1


make MCU_TARGET=atmega1281 BOOT_ADR=0x1F000 F_CPU=8000000 SD_CS_PORT=PORTE SD_CS_DDR=DDRE SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v0_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega1281 BOOT_ADR=0x1F000 F_CPU=8000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v1_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega1281 BOOT_ADR=0x1F000 F_CPU=8000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=0 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v0_cs8_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega1281 BOOT_ADR=0x1F000 F_CPU=8000000 SD_CS_PORT=PORTC SD_CS_DDR=DDRC SD_CS_BIT=0 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v1_cs8_$(F_CPU)L >> buildlog.txt 2>>&1

make MCU_TARGET=atmega1281 BOOT_ADR=0x1F000 F_CPU=16000000 SD_CS_PORT=PORTE SD_CS_DDR=DDRE SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v0_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega1281 BOOT_ADR=0x1F000 F_CPU=16000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v1_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega1281 BOOT_ADR=0x1F000 F_CPU=16000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=0 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v0_cs8_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega1281 BOOT_ADR=0x1F000 F_CPU=16000000 SD_CS_PORT=PORTC SD_CS_DDR=DDRC SD_CS_BIT=0 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v1_cs8_$(F_CPU)L >> buildlog.txt 2>>&1


make MCU_TARGET=atmega128 BOOT_ADR=0x1F000 F_CPU=8000000 SD_CS_PORT=PORTE SD_CS_DDR=DDRE SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v0_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega128 BOOT_ADR=0x1F000 F_CPU=8000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v1_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega128 BOOT_ADR=0x1F000 F_CPU=8000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=0 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v0_cs8_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega128 BOOT_ADR=0x1F000 F_CPU=8000000 SD_CS_PORT=PORTC SD_CS_DDR=DDRC SD_CS_BIT=0 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v1_cs8_$(F_CPU)L >> buildlog.txt 2>>&1

make MCU_TARGET=atmega128 BOOT_ADR=0x1F000 F_CPU=16000000 SD_CS_PORT=PORTE SD_CS_DDR=DDRE SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v0_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega128 BOOT_ADR=0x1F000 F_CPU=16000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v1_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega128 BOOT_ADR=0x1F000 F_CPU=16000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=0 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v0_cs8_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega128 BOOT_ADR=0x1F000 F_CPU=16000000 SD_CS_PORT=PORTC SD_CS_DDR=DDRC SD_CS_BIT=0 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v1_cs8_$(F_CPU)L >> buildlog.txt 2>>&1


make MCU_TARGET=atmega128a BOOT_ADR=0x1F000 F_CPU=8000000 SD_CS_PORT=PORTE SD_CS_DDR=DDRE SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v0_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega128a BOOT_ADR=0x1F000 F_CPU=8000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v1_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega128a BOOT_ADR=0x1F000 F_CPU=8000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=0 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v0_cs8_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega128a BOOT_ADR=0x1F000 F_CPU=8000000 SD_CS_PORT=PORTC SD_CS_DDR=DDRC SD_CS_BIT=0 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v1_cs8_$(F_CPU)L >> buildlog.txt 2>>&1

make MCU_TARGET=atmega128a BOOT_ADR=0x1F000 F_CPU=16000000 SD_CS_PORT=PORTE SD_CS_DDR=DDRE SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v0_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega128a BOOT_ADR=0x1F000 F_CPU=16000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v1_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega128a BOOT_ADR=0x1F000 F_CPU=16000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=0 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v0_cs8_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega128a BOOT_ADR=0x1F000 F_CPU=16000000 SD_CS_PORT=PORTC SD_CS_DDR=DDRC SD_CS_BIT=0 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v1_cs8_$(F_CPU)L >> buildlog.txt 2>>&1


make MCU_TARGET=atmega64 BOOT_ADR=0xF000 F_CPU=8000000 SD_CS_PORT=PORTE SD_CS_DDR=DDRE SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v0_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega64 BOOT_ADR=0xF000 F_CPU=8000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v1_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega64 BOOT_ADR=0x7000 F_CPU=8000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=0 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v0_cs8_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega64 BOOT_ADR=0x7000 F_CPU=8000000 SD_CS_PORT=PORTC SD_CS_DDR=DDRC SD_CS_BIT=0 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v1_cs8_$(F_CPU)L >> buildlog.txt 2>>&1

make MCU_TARGET=atmega64 BOOT_ADR=0xF000 F_CPU=16000000 SD_CS_PORT=PORTE SD_CS_DDR=DDRE SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v0_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega64 BOOT_ADR=0xF000 F_CPU=16000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v1_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega64 BOOT_ADR=0xF000 F_CPU=16000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=0 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v0_cs8_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega64 BOOT_ADR=0xF000 F_CPU=16000000 SD_CS_PORT=PORTC SD_CS_DDR=DDRC SD_CS_BIT=0 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v1_cs8_$(F_CPU)L >> buildlog.txt 2>>&1


make MCU_TARGET=atmega64a BOOT_ADR=0xF000 F_CPU=8000000 SD_CS_PORT=PORTE SD_CS_DDR=DDRE SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v0_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega64a BOOT_ADR=0xF000 F_CPU=8000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v1_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega64a BOOT_ADR=0xF000 F_CPU=8000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=0 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v0_cs8_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega64a BOOT_ADR=0xF000 F_CPU=8000000 SD_CS_PORT=PORTC SD_CS_DDR=DDRC SD_CS_BIT=0 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v1_cs8_$(F_CPU)L >> buildlog.txt 2>>&1

make MCU_TARGET=atmega64a BOOT_ADR=0xF000 F_CPU=16000000 SD_CS_PORT=PORTE SD_CS_DDR=DDRE SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v0_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega64a BOOT_ADR=0xF000 F_CPU=16000000 SD_CS_PORT=PORTD SD_CS_DDR=DDRD SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v1_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega64a BOOT_ADR=0xF000 F_CPU=16000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=0 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v0_cs8_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega64a BOOT_ADR=0xF000 F_CPU=16000000 SD_CS_PORT=PORTC SD_CS_DDR=DDRC SD_CS_BIT=0 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_v1_cs8_$(F_CPU)L >> buildlog.txt 2>>&1


make MCU_TARGET=atmega1280 BOOT_ADR=0x1F000 F_CPU=8000000 SD_CS_PORT=PORTG SD_CS_DDR=DDRG SD_CS_BIT=5 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
REM make MCU_TARGET=atmega1280 BOOT_ADR=0x1F000 F_CPU=8000000 SD_CS_PORT=PORTH SD_CS_DDR=DDRH SD_CS_BIT=5 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_cs8_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega1280 BOOT_ADR=0x1F000 F_CPU=8000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_cs10_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega1280 BOOT_ADR=0x1F000 F_CPU=8000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=0 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_cs53_$(F_CPU)L >> buildlog.txt 2>>&1

make MCU_TARGET=atmega1280 BOOT_ADR=0x1F000 F_CPU=16000000 SD_CS_PORT=PORTG SD_CS_DDR=DDRG SD_CS_BIT=5 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
REM make MCU_TARGET=atmega1280 BOOT_ADR=0x1F000 F_CPU=16000000 SD_CS_PORT=PORTH SD_CS_DDR=DDRH SD_CS_BIT=5 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_cs8_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega1280 BOOT_ADR=0x1F000 F_CPU=16000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_cs10_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega1280 BOOT_ADR=0x1F000 F_CPU=16000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=0 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_cs53_$(F_CPU)L >> buildlog.txt 2>>&1

make MCU_TARGET=atmega1280 BOOT_ADR=0x1F000 F_CPU=20000000 SD_CS_PORT=PORTG SD_CS_DDR=DDRG SD_CS_BIT=5 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
REM make MCU_TARGET=atmega1280 BOOT_ADR=0x1F000 F_CPU=20000000 SD_CS_PORT=PORTH SD_CS_DDR=DDRH SD_CS_BIT=5 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_cs8_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega1280 BOOT_ADR=0x1F000 F_CPU=20000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_cs10_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega1280 BOOT_ADR=0x1F000 F_CPU=20000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=0 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_cs53_$(F_CPU)L >> buildlog.txt 2>>&1


make MCU_TARGET=atmega640 BOOT_ADR=0xF000 F_CPU=8000000 SD_CS_PORT=PORTG SD_CS_DDR=DDRG SD_CS_BIT=5 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
REM make MCU_TARGET=atmega640 BOOT_ADR=0xF000 F_CPU=8000000 SD_CS_PORT=PORTH SD_CS_DDR=DDRH SD_CS_BIT=5 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_cs8_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega640 BOOT_ADR=0xF000 F_CPU=8000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_cs10_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega640 BOOT_ADR=0xF000 F_CPU=8000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=0 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_cs53_$(F_CPU)L >> buildlog.txt 2>>&1

make MCU_TARGET=atmega640 BOOT_ADR=0xF000 F_CPU=16000000 SD_CS_PORT=PORTG SD_CS_DDR=DDRG SD_CS_BIT=5 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
REM make MCU_TARGET=atmega640 BOOT_ADR=0xF000 F_CPU=16000000 SD_CS_PORT=PORTH SD_CS_DDR=DDRH SD_CS_BIT=5 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_cs8_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega640 BOOT_ADR=0xF000 F_CPU=16000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_cs10_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega640 BOOT_ADR=0xF000 F_CPU=16000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=0 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_cs53_$(F_CPU)L >> buildlog.txt 2>>&1

make MCU_TARGET=atmega640 BOOT_ADR=0xF000 F_CPU=20000000 SD_CS_PORT=PORTG SD_CS_DDR=DDRG SD_CS_BIT=5 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
REM make MCU_TARGET=atmega640 BOOT_ADR=0xF000 F_CPU=20000000 SD_CS_PORT=PORTH SD_CS_DDR=DDRH SD_CS_BIT=5 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_cs8_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega640 BOOT_ADR=0xF000 F_CPU=20000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_cs10_$(F_CPU)L >> buildlog.txt 2>>&1
make MCU_TARGET=atmega640 BOOT_ADR=0xF000 F_CPU=20000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=0 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_cs53_$(F_CPU)L >> buildlog.txt 2>>&1


REM make MCU_TARGET=atmega2560 BOOT_ADR=0x3F000 F_CPU=8000000 SD_CS_PORT=PORTG SD_CS_DDR=DDRG SD_CS_BIT=5 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
REM make MCU_TARGET=atmega2560 BOOT_ADR=0x3F000 F_CPU=8000000 SD_CS_PORT=PORTH SD_CS_DDR=DDRH SD_CS_BIT=5 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_cs8_$(F_CPU)L >> buildlog.txt 2>>&1
REM make MCU_TARGET=atmega2560 BOOT_ADR=0x3F000 F_CPU=8000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_cs10_$(F_CPU)L >> buildlog.txt 2>>&1
REM make MCU_TARGET=atmega2560 BOOT_ADR=0x3F000 F_CPU=8000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=0 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_cs53_$(F_CPU)L >> buildlog.txt 2>>&1

REM make MCU_TARGET=atmega2560 BOOT_ADR=0x3F000 F_CPU=16000000 SD_CS_PORT=PORTG SD_CS_DDR=DDRG SD_CS_BIT=5 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
REM make MCU_TARGET=atmega2560 BOOT_ADR=0x3F000 F_CPU=16000000 SD_CS_PORT=PORTH SD_CS_DDR=DDRH SD_CS_BIT=5 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_cs8_$(F_CPU)L >> buildlog.txt 2>>&1
REM make MCU_TARGET=atmega2560 BOOT_ADR=0x3F000 F_CPU=16000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_cs10_$(F_CPU)L >> buildlog.txt 2>>&1
REM make MCU_TARGET=atmega2560 BOOT_ADR=0x3F000 F_CPU=16000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=0 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_cs53_$(F_CPU)L >> buildlog.txt 2>>&1

REM make MCU_TARGET=atmega2560 BOOT_ADR=0x3F000 F_CPU=20000000 SD_CS_PORT=PORTG SD_CS_DDR=DDRG SD_CS_BIT=5 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_cs4_$(F_CPU)L >> buildlog.txt 2>>&1
REM make MCU_TARGET=atmega2560 BOOT_ADR=0x3F000 F_CPU=20000000 SD_CS_PORT=PORTH SD_CS_DDR=DDRH SD_CS_BIT=5 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_cs8_$(F_CPU)L >> buildlog.txt 2>>&1
REM make MCU_TARGET=atmega2560 BOOT_ADR=0x3F000 F_CPU=20000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=4 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_cs10_$(F_CPU)L >> buildlog.txt 2>>&1
REM make MCU_TARGET=atmega2560 BOOT_ADR=0x3F000 F_CPU=20000000 SD_CS_PORT=PORTB SD_CS_DDR=DDRB SD_CS_BIT=0 USE_LED=0 USE_UART=0 ADDED_CFLAGS="-Wextra -Wno-strict-aliasing" TARGET=$(MCU_TARGET)_cs53_$(F_CPU)L >> buildlog.txt 2>>&1

make clean >> buildlog.txt 2>>&1
del *.elf >> buildlog.txt 2>>&1
avr-size *.hex > bootloader_size.txt
echo build complete
pause
buildlog.txt
del buildlog.txt
bootloader_size.txt
del bootloader_size.txt
exit

Variant IDs(one ID is used for multiple variants when the pin mapping for all allowed SD CS pins are the same):

ATmega1284/644/324/32:
avr_developers/standard 0
bobuino 1
sleepingbeauty/calunium-pcb/calunium-stripboard 2
goldilocks/wildfirev2 3
wildfirev3 4
WiringS 5
WiringSPlayShield 6

ATmega1281/128/64:
megacore-standard 0
Wiring1 1

